import chimera.extension
import threading
import os
import time

# -----------------------------------------------------------------------------
#
class helixhunter_EMO(chimera.extension.EMO):
	def name(self):
		return "Helixhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs helixhunter2'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('hhc').gui()

		return None

chimera.extension.manager.registerExtension(helixhunter_EMO(__file__))

class foldhunter_EMO(chimera.extension.EMO):
	def name(self):
		return "Foldhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs AIRS foldhunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('fhc').gui()

		return None

chimera.extension.manager.registerExtension(foldhunter_EMO(__file__))
'''
class hh3c_EMO(chimera.extension.EMO):
	def name(self):
		return "Helixhunter3"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'Super-mega-ultra-hyper-helixhunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('hh3c').gui()

		return None

chimera.extension.manager.registerExtension(hh3c_EMO(__file__))
'''
class filters_EMO(chimera.extension.EMO):
       def name(self):
	       return "Filters"

       def categories(self):
	       "Return list of category names in which this extension belongs"
	       return ["AIRS"]

       def description(self):
	       "Return short description (appropriate for balloon help)"
	       return '3D map filters'

       def documentation(self):
	       "Return full documention URL"
	       return None

       def hasUI(self):
	       "Return whether extension activation starts a UI"
	       return 1

       def activate(self):
	       "Activate extension and return an instance (if appropriate)"
	       self.module('filters').gui()

	       return None

chimera.extension.manager.registerExtension(filters_EMO(__file__))


class sshunter_EMO(chimera.extension.EMO):
	def name(self):
		return "SSEhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs ssehunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('ssc').gui()

		return None

chimera.extension.manager.registerExtension(sshunter_EMO(__file__))

class ssebuilder_EMO(chimera.extension.EMO):
	def name(self):
		return "SSEbuilder"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs ssebuilder'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('ssebuilder').gui()

		return None

chimera.extension.manager.registerExtension(ssebuilder_EMO(__file__))

class modeviewer_EMO(chimera.extension.EMO):
	def name(self):
		return "ModeViewer"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs modeviewer'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('modeviewer').gui()

		return None

chimera.extension.manager.registerExtension(modeviewer_EMO(__file__))
"""
class AIRS_EMO(chimera.extension.EMO):
       def name(self):
	       return "AIRS"

       def categories(self):
	       "Return list of category names in which this extension belongs"
	       return ["AIRS"]

       def description(self):
	       "Return short description (appropriate for balloon help)"
	       return 'runs AIRS'

       def documentation(self):
	       "Return full documention URL"
	       return None

       def hasUI(self):
	       "Return whether extension activation starts a UI"
	       return 1

       def activate(self):
	       "Activate extension and return an instance (if appropriate)"
	       self.module('AIRS').gui()

	       return None

chimera.extension.manager.registerExtension(AIRS_EMO(__file__))
"""
class flexible_EMO(chimera.extension.EMO):
	def name(self):
		return "Flexible Foldhunter"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'Flexible Foldhunter'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('flexible').gui()

		return None

chimera.extension.manager.registerExtension(flexible_EMO(__file__))

class pdb2cmm_EMO(chimera.extension.EMO):
	def name(self):
		return "pdb2cmm"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs pdb2cmm.py'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('p2c').gui()

		return None

chimera.extension.manager.registerExtension(pdb2cmm_EMO(__file__))

class cmm2pdb_EMO(chimera.extension.EMO):
	def name(self):
		return "cmm2pdb"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs cmm2pdb.py'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('c2p').gui()

		return None

chimera.extension.manager.registerExtension(cmm2pdb_EMO(__file__))
"""
class morph_EMO(chimera.extension.EMO):
	def name(self):
		return "morph"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'runs cmm-morph.py'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('morph').gui()

		return None

chimera.extension.manager.registerExtension(morph_EMO(__file__))
"""
class rt_EMO(chimera.extension.EMO):
	def name(self):
		return "Rotate and Translate"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'rotates and translates a map. also runs ccf2.py'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('rt').gui()

		return None

chimera.extension.manager.registerExtension(rt_EMO(__file__))

class pdb2mrc_EMO(chimera.extension.EMO):
	def name(self):
		return "pdb2mrc"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'generates a MRC from a PDB'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('pdb2mrc').gui()

		return None

chimera.extension.manager.registerExtension(pdb2mrc_EMO(__file__))
"""
class ssesk_EMO(chimera.extension.EMO):
	def name(self):
		return "sse skeleton"

	def categories(self):
		"Return list of category names in which this extension belongs"
		return ["AIRS"]

	def description(self):
		"Return short description (appropriate for balloon help)"
		return 'generates sse and skeletons from a MRC file'

	def documentation(self):
		"Return full documention URL"
		return None

	def hasUI(self):
		"Return whether extension activation starts a UI"
		return 1

	def activate(self):
		"Activate extension and return an instance (if appropriate)"
		self.module('ssesk').gui()

		return None

chimera.extension.manager.registerExtension(ssesk_EMO(__file__))
"""

